package net.sf.alchim.codeplus.spoonchecker;

import spoon.reflect.declaration.CtClass;
import spoon.reflect.declaration.CtExecutable;
import spoon.reflect.declaration.ModifierKind;

public class EmptyMethodBodyAnalyzer extends AbstractAnalyzer<CtExecutable<?>> {

    public void analyze(CtExecutable<?> element) {
        if ((element.getParent(CtClass.class) != null)
                && !element.getModifiers().contains(ModifierKind.ABSTRACT)
                && (element.getBody().getStatements().size() == 0)
                && (element.getBody().getDocComment() == null)) {
            report(element, "Empty block");
        }
    }

}
