package net.sf.alchim.codeplus.spoonchecker;

import spoon.reflect.declaration.CtElement;
import spoon.reflect.declaration.CtExecutable;
import spoon.reflect.declaration.CtField;
import spoon.reflect.declaration.CtModifiable;
import spoon.reflect.declaration.CtSimpleType;
import spoon.reflect.declaration.ModifierKind;

/**
 * Report warnings when undocumented elements are found.
 */
public class JavadocAnalyzer extends AbstractAnalyzer<CtElement> {

    @Override
    public void analyze(CtElement element) {
        if ((element instanceof CtSimpleType) || (element instanceof CtField) || (element instanceof CtExecutable)) {
            if (((CtModifiable) element).getModifiers().contains(ModifierKind.PUBLIC) || ((CtModifiable) element).getModifiers().contains(ModifierKind.PROTECTED)) {
                // if(element instanceof CtMethod) {
                // ((CtMethod)element).getReference().getOverloadingExecutable()
                // }
                if ((element.getDocComment() == null) || element.getDocComment().equals("")) {
                    report(element, "undocument element");
                }
            }
        }
    }

}
