package net.sf.alchim.codeplus.spoonchecker;

import spoon.processing.AbstractProblemFixer;
import spoon.reflect.Changes;
import spoon.reflect.declaration.CtElement;

public class SuppressWarningFixer extends AbstractProblemFixer<CtElement> {
    private String type_;

    public SuppressWarningFixer(Class<?> analyzerType) {
        type_ = analyzerType.getSimpleName();
    }

    public String getDescription() {
        return getLabel();
    }

    public String getLabel() {
        return "Add @SuppressWarning '" + type_ + "'";
    }

    public Changes run(CtElement element) {
        getFactory().Annotation().annotate(element, SuppressWarnings.class, "SuppressWarning", type_);
        Changes back = new Changes();
        back.getModified().add(element);
        return back;
    }

}
