package net.sf.alchim.codeplus.spoonprocessor;

import spoon.processing.Processor;
import spoon.processing.Severity;
import spoon.reflect.declaration.CtElement;
import spoon.reflect.declaration.SourcePosition;

@SuppressWarnings("serial")
public class ProcessingException extends RuntimeException {

    public <E extends CtElement> ProcessingException(Processor<E> processor, E element, Exception exc) {
        this(processor, element, element.getPosition(), exc);
    }

    public <E extends CtElement> ProcessingException(Processor<E> processor, E element, SourcePosition pos, Exception exc) {
        super(String.format("faile on %s.process('%s') at %s:%d:%d, (%s)", processor.getClass().getSimpleName(), element.getSignature(), pos.getFile(), pos.getLine(), pos.getColumn(), exc.getMessage()), exc);
        processor.getEnvironment().report(processor, Severity.ERROR, element, getMessage());
    }


}
