package net.sf.alchim.codeplus.spoonprocessor;

import java.lang.annotation.Annotation;
import java.util.Collection;
import java.util.Set;

import spoon.reflect.code.CtAbstractInvocation;
import spoon.reflect.code.CtStatement;
import spoon.reflect.declaration.CtAnnotation;
import spoon.reflect.declaration.CtElement;
import spoon.reflect.declaration.SourcePosition;
import spoon.reflect.visitor.Filter;
import spoon.reflect.visitor.Query;

public class ProcessorHelper {

    public static CtAnnotation<?> findAnnotation(CtElement elt, Class<? extends Annotation> type) {
        CtAnnotation<?> annotation = null;
        for (CtAnnotation<?> a : elt.getAnnotations()) {
            if (type.equals(a.getActualAnnotation().annotationType())) {
                annotation = a;
                break;
            }
        }
        return annotation;
    }

    public static void removeAnnotation(CtElement elt, Class<? extends Annotation> type) {
        Set<CtAnnotation<?>> annotations = elt.getAnnotations();
        for(CtAnnotation<?> cta : annotations) {
            try {
                if (cta.getActualAnnotation().annotationType().equals(type)) {
                    annotations.remove(cta);
                }
            } catch(NullPointerException exc) {

            }
        }
        elt.setAnnotations(annotations);
    }

    public static void forcePositionOfEveryStmt(CtStatement stmt, SourcePosition position) {
        Collection<CtAbstractInvocation<?>> is = Query.getElements(stmt, new Filter<CtAbstractInvocation<?>>() {
            @SuppressWarnings("unchecked")
            public Class getType() {
                return CtAbstractInvocation.class;
            }

            public boolean matches(CtAbstractInvocation<?> element) {
                return true;
            }
        });
        for (CtAbstractInvocation<?> i : is) {
            i.setPosition(position);
        }
    }
}
